unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Menus, ExtCtrls, ScktComp, ComCtrls;

const WM_TASKBAREVENT = WM_USER+1;

type
  TserverForm = class(TForm)
    ServerSocket: TServerSocket;
    Edit1: TEdit;
    Label1: TLabel;
    usersListBox: TListBox;
    Label2: TLabel;
    Memo1: TMemo;
    usersipListBox: TListBox;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Panel1: TPanel;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Verbinden1: TMenuItem;
    Verbindungtrennen1: TMenuItem;
    kickBitBtn: TBitBtn;
    startBitBtn: TBitBtn;
    stopBitBtn: TBitBtn;
    Label7: TLabel;
    Label8: TLabel;
    exitBitBtn: TBitBtn;
    RichEdit1: TRichEdit;
    userComboBox: TComboBox;
    userCheckBox: TCheckBox;
    Label9: TLabel;
    Edit2: TEdit;
    Button1: TButton;
    Minimieren1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Datei2: TMenuItem;
    Serverstarten1: TMenuItem;
    Serverstoppen1: TMenuItem;
    Beenden1: TMenuItem;
    Beenden2: TMenuItem;
    Image1: TImage;
    N1: TMenuItem;
    Hilfe1: TMenuItem;
    Credits1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure startBitBtnClick(Sender: TObject);
    procedure stopBitBtnClick(Sender: TObject);
    procedure ServerSocketAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure exitBitBtnClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure kickBitBtnClick(Sender: TObject);
    procedure Verbinden1Click(Sender: TObject);
    procedure Verbindungtrennen1Click(Sender: TObject);
    procedure Userrausschmeien1Click(Sender: TObject);
    procedure Minimieren1Click(Sender: TObject);
    procedure Datei2Click(Sender: TObject);
    procedure Serverstarten1Click(Sender: TObject);
    procedure Serverstoppen1Click(Sender: TObject);
    procedure Beenden1Click(Sender: TObject);
    procedure Beenden2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Hilfe1Click(Sender: TObject);
    procedure Credits1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
     procedure WMTASKBAREVENT(var message: TMessage); message WM_TASKBAREVENT;
    { Public-Deklarationen }
  end;

var
  serverForm: TserverForm;


{-------------allgemeine Records---------------- }
TYPE
   T_user= RECORD
               ip                : string;
               name              : string;
               nummer            : string;
             END;
   T_users = Array[0..100] of T_user;


{------------allgemeine Variablen-----------}

var
  anzahluser  : integer;
  user        : T_users;

implementation

uses shellapi, Unit1, Unit2, Unit7;

{$R *.DFM}


{-----------------------eigene Proceduren-----------------------------}

procedure listeaktualisieren;
var i : integer;
begin
  serverform.userslistbox.Items.Clear;
  serverform.usersiplistbox.Items.Clear;
  serverform.usercombobox.Clear;

  for i:=0 to anzahluser do
  begin
   serverform.userslistbox.Items.add(user[i].name + ' (' + user[i].nummer +')');
   serverform.usersiplistbox.Items.add(user[i].ip);
   serverform.usercombobox.Items.Add(inttostr(i));
  end;

end;

function usersuche(suche:string):integer;
var i:integer;
    fertig: boolean;
begin
 if anzahluser > -1 then
 begin
  i:=0;
  fertig:=false;
  usersuche:=-1;
  repeat
    if user[i].name=suche then
    begin
         usersuche:=strtoint(user[i].nummer);
         fertig:=true;
    end;
    if (i < anzahluser) then inc(i) else fertig:=true;
  until fertig=true;
 end else usersuche:=-1;
end;

procedure TaskBarAddIcon;
var tnid : TNOTIFYICONDATA ;
begin
    tnid.cbSize := sizeof(TNOTIFYICONDATA); // Grenangabe der Struktur
    tnid.Wnd := serverForm.handle;               // Handle des Message-Empfngers
    tnid.uID := 1;                          // ID beliebig
    tnid.uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP;  // siehe Tabelle
    tnid.uCallbackMessage := WM_TASKBAREVENT;        // Message# fr Form1
    tnid.hIcon := serverform.image1.picture.icon.handle;  // Iconhandle
    strcopy(tnid.szTip,'AlphaChat');                // Tooltiptext
    Shell_NotifyIcon(NIM_ADD, @tnid);                // Registrieren ...
end;

procedure TaskBarRemoveIcon;
var tnid : TNOTIFYICONDATA ;
begin
    tnid.cbSize := sizeof(TNOTIFYICONDATA);
    tnid.Wnd := serverForm.handle;
    tnid.uID := 1;
    Shell_NotifyIcon(NIM_DELETE, @tnid);
end;

procedure TserverForm.WMTASKBAREVENT(var message: TMessage);
var point : TPoint;
begin
    case message.LParamLo of
         WM_LBUTTONDBLCLK : begin
                                 serverform.show;
                            end;
         WM_RBUTTONDOWN   : begin
                                 GetCursorPos(point);
                                 popupmenu1.popup(point.x,point.y);
//                                 if serversocket.active then popupmenu1.Items[1].Checked:=true;
//                                 if serversocket.active then popupmenu1.Items[1].Checked:=true;
                                 popupmenu1.Items[2].Checked:=true;
                            end;
    end;
end;

{-----------------------ende eigener Proceduren-----------------------}

procedure TserverForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 serversocket.active:=false;
 clientform.clientsocket.active:=false;
 auswahlform.close;
 TaskBarRemoveIcon;
end;

procedure TserverForm.startBitBtnClick(Sender: TObject);
begin
 stopbitbtn.Click;
 serverstarten1.checked:=true;
 serverstoppen1.checked:=false;
 verbinden1.checked:=true;
 verbindungtrennen1.checked:=false;
 anzahluser:=-1;  //weil 0 der erste User ist
 clientform.ClientSocket.Active := False;
// showmessage('stop');
 ServerSocket.Port := strtoint(edit1.text);
// serversocket.Socket.LocalAddress;
 if not serversocket.Active then serversocket.active:= true;
 serversocket.Open;
 label5.caption:=serversocket.Socket.LocalHost;
 memo1.lines.add('Servername: ' + serversocket.Socket.LocalHost);
 //memo1.lines.add('Serverip: ' + serversocket.Socket.LocalAddress);

end;

procedure TserverForm.stopBitBtnClick(Sender: TObject);
begin
 serverstarten1.checked:=false;
 serverstoppen1.checked:=true;
 verbinden1.checked:=false;
 verbindungtrennen1.checked:=true;
 //serversocket.active:=false;
 serversocket.Close;
 userslistbox.clear;
 usersiplistbox.clear;
 label5.caption:='server';
end;

procedure TserverForm.ServerSocketAccept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Memo1.lines.add('Connected to: ' + Socket.RemoteAddress);
end;

procedure TserverForm.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  Memo1.Lines.Add('Client '+ Socket.RemoteAddress +' connected');
   memo1.lines.add('Serverip: ' + serversocket.Socket.localaddress);

end;

procedure TserverForm.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
memo1.lines.add(Socket.RemoteAddress + 'disconnect');
end;

procedure TserverForm.ServerSocketClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
  var i: integer;
      text,nachricht, befehl, temp2: string;

function befehlauswerten(ueb:string):string;
var
 befehl,temp, bname, bname2, farbe, bip, datei :string;
 i                              :integer;
begin
  befehl:=copy(ueb,0,pos(':' , ueb)-1); //kopiert ersten befehl heraus der regelt, welche aktion gestartet wird

  if befehl='user' then
     begin
          temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb)); //entfernt ersten befehl
          bname:=copy(temp,0,pos(':', temp)-1);                        //kopiert Benutzername heraus
          farbe:=copy(temp,pos(':', temp)+1,pos('#', temp)-pos(':', temp)-1);  //kopiert Benutzerfarbe heraus

          befehlauswerten:='$#farbe:' + farbe + '#'+ bname + ': ' + copy(ueb,pos('#',ueb)+1,length(ueb));  //Gibt Nachricht fr clients zurck
          richedit1.SelAttributes.color:=strtoint(farbe);
          richedit1.Lines.Add(copy(ueb,pos('#',ueb)+1,length(ueb)));
     end;

 if befehl='pmessage' then
    begin
          temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb)); //entfernt ersten befehl
          bname:=copy(temp,0,pos(':', temp)-1);                        //kopiert Benutzername wo die Nachricht hingeschickt wird heraus
          temp:=copy(temp,pos(':', temp) + 1,pos('#', temp)-pos(':', temp)-1);             //kopiert Benutzername von wem die Nachricht geschickt wurde heraus
          befehlauswerten:='pmassage';  //Gibt Nachricht fr clients zurck
          ServerSocket.Socket.Connections[usersuche(bname)].SendText('$#pmassage:' + temp + '#Private Nachricht: ' + copy(ueb,pos('#',ueb)+1,length(ueb)));    //Sende Private Nachricht an User
    end;

 if befehl='pchat' then
    begin
          temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb)); //entfernt ersten befehl
          bname:=copy(temp,0,pos(':', temp)-1);                        //kopiert Benutzername wo die Nachricht hingeschickt wird heraus
          temp:=copy(temp,pos(':', temp) + 1,pos('#', temp)-pos(':', temp)-1);  //kopiert Benutzername von wem die Nachricht geschickt wurde heraus
          ServerSocket.Socket.Connections[usersuche(bname)].SendText('$#pchat:' + temp + '#' + copy(ueb,pos('#',ueb)+1,length(ueb)));    //Sende Private Nachricht an User
    end;

 if befehl='neu' then
    begin
          label7.caption:=inttostr(anzahluser+1);
          temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb)); //entfernt ersten befehl
          bname:=copy(temp,0,pos(':', temp)-1);                        //kopiert Benutzername heraus
          temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //kopiert Benutzernameanweisung heraus
          farbe:=copy(temp,0,pos(':', temp)-1);                        //kopiert Benutzerfarbe heraus
          bip:=copy(temp,pos(':', temp)+1,pos('#', temp)-pos(':', temp)-1);  //kopiert Benutzerip heraus

          if (usersuche(bname)=-1) then
          begin
            inc(anzahluser);                                             //gibt anzahl der user an

            user[anzahluser].ip:=bip;
            user[anzahluser].name:=bname;
            user[anzahluser].nummer:=inttostr(anzahluser);
            listeaktualisieren;

            temp:='$#neu';
            for i:=0 to anzahluser do
            begin
             temp:=temp + ':' + user[i].name + ':' + user[i].ip;
             end;
             befehlauswerten:=temp + '#';                                 //Gibt gibt alle Benutzernamen an Clients weiter
          end
          else ServerSocket.Socket.Connections[anzahluser+1].SendText('$#noconnect:noconnect#');    //doppelter Benutzername

    end;

 if (befehl='file') or (befehl='fileabgelent') or (befehl='fileangenommen') then
    begin
       //$#file:' + bname(sender) + ':' + user[sentfile+1].name(empfnger) + ':' + datei + '#'
       temp:=copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb));            //entfernt Befehl
       bname:=copy(temp,0,pos(':', temp)-1);                           //kopiert Benutzername vom Sender heraus
       temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //kopiert Restbefehl heraus
       bname2:=copy(temp,0,pos(':', temp)-1);                            //kopiert Name vom Empfnger heraus
       temp:=copy(temp,pos(':', temp)+1,pos('#', temp));            //kopiert Benutzernameanweisung heraus
       datei:=copy(temp,0,pos('#', temp)-1);                          //kopiert dateinamen heraus
       if befehl='file' then ServerSocket.Socket.Connections[usersuche(bname2)].SendText('$#file:' + bname + ':' + user[usersuche(bname)].ip + ':' + datei + '#');    //Sende Datei an User
       if befehl='fileabgelent' then ServerSocket.Socket.Connections[usersuche(bname2)].SendText('$#fileabgelehnt:' + bname2 + ':' + datei + '#');    //Sende Datei an User
       if befehl='fileangenommen' then
       begin
       ServerSocket.Socket.Connections[usersuche(bname)].SendText('$#fileangenommen:' + bname2 + ':' + user[usersuche(bname2)].ip + ':' + datei + '#');    //Sende Datei an User
       //showmessage('$#fileangenommen:' + bname + ':' + user[usersuche(bname)].ip + ':' + datei + '#');
       end;
    end;

 if befehl='disconnect' then
    begin
       bname:=copy(ueb,pos(':', ueb)+1,pos('#', ueb)-pos(':', ueb)-1); //Filtert Benutzername von Disconnecter heraussads
       usersuche(bname);
       if not(usersuche(bname)=anzahluser) then
       for i:=usersuche(bname) to anzahluser-1 do
       begin
           user[i].ip:=user[i+1].ip;
           user[i].name:=user[i+1].name;
           user[i].nummer:=inttostr(i);
       end;
       dec(anzahluser);
       listeaktualisieren;

        temp:='$#neu';
        for i:=0 to anzahluser do
        begin
         temp:=temp + ':' + user[i].name + ':' + user[i].ip;
        end;

        befehlauswerten:=temp + '#';                                 //Gibt gibt alle Benutzernamen an Clients weiter
//        ServerSocket.Socket.Connections[anzahluser+1].SendText(temp + '#'); //damit der letzte Chatter die neue Benutzerliste bekommt

    end;
end;

begin
  //beispielnachricht:= '$#user:md:clred#hallo leute';
  nachricht:=Socket.ReceiveText;
  memo1.Lines.add(Socket.RemoteAddress + nachricht);
  if not(copy(nachricht,0,2)='$#') then
     begin
       befehl:='Error';
       nachricht:='Es ist ein bertragungsfehler aufgetreten';
     end
     else
     begin
       temp2:=copy(nachricht,3,length(nachricht));
//       showmessage(temp2);
       nachricht:=befehlauswerten(temp2);
       if not((nachricht='pmassage') or (nachricht='pchat')) then
         begin
//              showmessage(nachricht);
            for i:=0 to anzahluser do
              ServerSocket.Socket.Connections[i].SendText(nachricht);
         end;
     end;
end;

procedure TserverForm.exitBitBtnClick(Sender: TObject);
begin
 serverform.Close;
end;

procedure TserverForm.Button1Click(Sender: TObject);
var i: integer;
    nachricht:string;
begin
nachricht:='$#farbe:' + inttostr(clred) + '#'+ 'Server' + ': ' + edit2.text;
if (usercheckbox.Checked) or (usercombobox.text='') then
   for i:=0 to anzahluser do
       begin
              ServerSocket.Socket.Connections[i].SendText(nachricht);
       end
else ServerSocket.Socket.Connections[strtoint(usercombobox.text)].SendText(nachricht);
end;

procedure TserverForm.kickBitBtnClick(Sender: TObject);
begin

 if not(userslistbox.itemindex=-1) then
 //showmessage(userslistbox.items.strings[userslistbox.itemindex]);
 ServerSocket.Socket.Connections[userslistbox.itemindex].SendText('$#kill:kill#');
end;

procedure TserverForm.Verbinden1Click(Sender: TObject);
begin
 startbitbtn.click;
end;

procedure TserverForm.Verbindungtrennen1Click(Sender: TObject);
begin
 stopbitbtn.click;
end;

procedure TserverForm.Userrausschmeien1Click(Sender: TObject);
begin
 kickbitbtn.click;
end;

procedure TserverForm.Minimieren1Click(Sender: TObject);
begin
  self.hide;
  TaskBarAddIcon;
end;

procedure TserverForm.Datei2Click(Sender: TObject);
begin
  TaskBarRemoveIcon;
  self.visible:=true;
end;

procedure TserverForm.Serverstarten1Click(Sender: TObject);
begin
 startbitbtn.click;
end;

procedure TserverForm.Serverstoppen1Click(Sender: TObject);
begin
 stopbitbtn.click;
end;

procedure TserverForm.Beenden1Click(Sender: TObject);
begin
 serverform.Close;
end;

procedure TserverForm.Beenden2Click(Sender: TObject);
begin
 serverform.Close;
end;

procedure TserverForm.FormShow(Sender: TObject);
begin
startbitbtn.SetFocus;
end;

procedure TserverForm.Hilfe1Click(Sender: TObject);
begin
 serverform.enabled:=false;
 HilfeForm.visible:=true;
 HilfeForm.PageControl1.ActivePageIndex:=1;

end;

procedure TserverForm.Credits1Click(Sender: TObject);
begin
 serverform.enabled:=false;
 HilfeForm.visible:=true;
 HilfeForm.PageControl1.ActivePageIndex:=2;

end;

end.
